#include <stdio.h>
#include <string.h>

#include <Xm/Xm.h>
#include <Xm/TextF.h>

#include "getdir.h"

extern Widget fm_textfield, fm_container;
extern char current_wd[120];

void fm_container_select(Widget w, XtPointer client_data, 
			 XmContainerSelectCallbackStruct call_data)
{
  char out_str[150];
  WidgetList sel_wid;
  int sel_wid_count;

  XtVaGetValues(fm_container, XmNselectedObjects, &sel_wid, 
		XmNselectedObjectCount, &sel_wid_count, NULL);

  if (sel_wid_count && strcmp(XtName(sel_wid[0]), "."))
    if (strcmp(XtName(sel_wid[0]), "..") == 0)
      sprintf(out_str, "%s", getparent());
    else
      if (strcmp(current_wd, "/"))
	sprintf(out_str, "%s/%s", current_wd, XtName(sel_wid[0]));
      else
	sprintf(out_str, "/%s", XtName(sel_wid[0]));
  else
    sprintf(out_str, "%s", current_wd);
  XtVaSetValues(fm_textfield, XmNvalue, out_str, NULL);
}
